#ifndef	___DecodeSet_H_
#define	___DecodeSet_H_
//------------------------------------------------------------------------------
// ＢeＯＳヘッダ
#include <DataIO.h>
// プロジェクトヘッダ
#include "VPLHAKernel.h"
//------------------------------------------------------------------------------
class	TMeltInfo;
//==============================================================================
class	TDecodeSet
		// 各解凍処理の違いを統合する抽象スーパークラス
{
public:
	virtual	~TDecodeSet();

	virtual unsigned short	DecodeC(BPositionIO *oInSrc,TMeltInfo *oMeltInfo) = 0;
	virtual unsigned short	DecodeP(BPositionIO *oInSrc,TMeltInfo *oMeltInfo) = 0;
	virtual void			StartDecode(BPositionIO *oInSrc,TMeltInfo *oMeltInfo) = 0;

protected:
	void			FillBuf(unsigned char n,BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
	unsigned short	GetBits(unsigned char n,BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
	void			InitGetBits(BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
	status_t		MakeTable(short oNChar,unsigned char oBitLen[],short oTableBits,unsigned short oTable[],TMeltInfo *oMeltInfo);
	status_t		ReadCLen(BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
	status_t		ReadPtLen(short nn,short oNBit,short oISpecial,BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
};
//==============================================================================
class	TLh5DecodeSet : public TDecodeSet
		// "-lh5-" 用の解凍処理
{
public:
	virtual unsigned short	DecodeC(BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
	virtual unsigned short	DecodeP(BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
	virtual void			StartDecode(BPositionIO *oInSrc,TMeltInfo *oMeltInfo);
};
//==============================================================================
#endif	//___DecodeSet_H_
