#ifndef	___LHAConsts_H_
#define	___LHAConsts_H_
//------------------------------------------------------------------------------
//==============================================================================
#define METHOD_TYPE_STRAGE	5
#define DELIM				('/')
#define DELIM2				(0xFF)
#define LZHEADER_STRAGE		4096
#define NP					(MAX_DICBIT + 1)
#define NT					(USHRT_BIT + 3)
#define PBIT				5		/* smallest integer such that (1 << PBIT) > * NP */
#define TBIT 				5		/* smallest integer such that (1 << TBIT) > * NT */
#define CBIT				9		/* $\lfloor \log_2 NC \rfloor + 1$ */
#define USHRT_BIT			16		/* (CHAR_BIT * sizeof(ushort)) */
#define NC 					(UCHAR_MAX + MAXMATCH + 2 - THRESHOLD)
#define NPT					0x80
#define CRCPOLY				0xA001	/* CRC-16 */

#ifdef SUPPORT_LH7
#define MAX_DICBIT			16      /* lh7 use 16bits */
#endif

#ifndef SUPPORT_LH7
#define MAX_DICBIT			15      /* lh6 use 15bits */
#endif

#define MAX_DICSIZ			(1 << MAX_DICBIT)
#define MATCHBIT			8	/* bits for MAXMATCH - THRESHOLD */
#define MAXMATCH			256	/* formerly F (not more than UCHAR_MAX + 1) */
#define THRESHOLD			3	/* choose optimal value */

#define BUFFERSIZE	2048

#define I_HEADER_SIZE			0
#define I_HEADER_CHECKSUM		1
#define I_METHOD				2
#define I_PACKED_SIZE			7
#define I_ORIGINAL_SIZE			11
#define I_LAST_MODIFIED_STAMP	15
#define I_ATTRIBUTE				19
#define I_HEADER_LEVEL			20
#define I_NAME_LENGTH			21
#define I_NAME					22

#define UNIX_FILE_TYPEMASK		0170000
#define UNIX_FILE_REGULAR		0100000
#define UNIX_FILE_DIRECTORY		0040000
#define UNIX_FILE_SYMLINK		0120000
#define UNIX_SETUID				0004000
#define UNIX_SETGID				0002000
#define UNIX_STYCKYBIT			0001000
#define UNIX_OWNER_READ_PERM	0000400
#define UNIX_OWNER_WRITE_PERM	0000200
#define UNIX_OWNER_EXEC_PERM	0000100
#define UNIX_GROUP_READ_PERM	0000040
#define UNIX_GROUP_WRITE_PERM	0000020
#define UNIX_GROUP_EXEC_PERM	0000010
#define UNIX_OTHER_READ_PERM	0000004
#define UNIX_OTHER_WRITE_PERM	0000002
#define UNIX_OTHER_EXEC_PERM	0000001
#define UNIX_RW_RW_RW			0000666

#define EXTEND_GENERIC			0
#define EXTEND_UNIX				'U'
#define EXTEND_MSDOS			'M'
#define EXTEND_MACOS			'm'
#define EXTEND_OS9				'9'
#define EXTEND_OS2				'2'
#define EXTEND_OS68K			'K'
#define EXTEND_OS386			'3'	/* OS-9000??? */
#define EXTEND_HUMAN			'H'
#define EXTEND_CPM				'C'
#define EXTEND_FLEX				'F'
#define EXTEND_RUNSER			'R'

#define LZHUFF0_METHOD			"-lh0-"
#define LZHUFF1_METHOD			"-lh1-"
#define LZHUFF2_METHOD			"-lh2-"
#define LZHUFF3_METHOD			"-lh3-"
#define LZHUFF4_METHOD			"-lh4-"
#define LZHUFF5_METHOD			"-lh5-"
#define LZHUFF6_METHOD			"-lh6-"
#define LZHUFF7_METHOD			"-lh7-"
#define LARC_METHOD				"-lzs-"
#define LARC5_METHOD			"-lz5-"
#define LARC4_METHOD			"-lz4-"
#define LZHDIRS_METHOD			"-lhd-"

#define LZHUFF0_METHOD_NUM		0
#define LZHUFF1_METHOD_NUM		1
#define LZHUFF2_METHOD_NUM		2
#define LZHUFF3_METHOD_NUM		3
#define LZHUFF4_METHOD_NUM		4
#define LZHUFF5_METHOD_NUM		5
#define LZHUFF6_METHOD_NUM		6
#define LZHUFF7_METHOD_NUM		7
#define LARC_METHOD_NUM			8
#define LARC5_METHOD_NUM		9
#define LARC4_METHOD_NUM		10
#define LZHDIRS_METHOD_NUM		11
//==============================================================================
#endif	//___LHAConsts_H_
