#ifndef	___LHAKernel_H_
#define	___LHAKernel_H_
//------------------------------------------------------------------------------
// ＢeＯＳヘッダ
#include <DataIO.h>
// Ｃ++ヘッダ
#include <string>
// プロジェクトヘッダ
#include "VPLHAKernel.h"
//------------------------------------------------------------------------------
using namespace	std;
//==============================================================================
class	TLHAKernel
{
public:
	TLHAKernel();
	~TLHAKernel();

	status_t	Extract(const char *oDestFolder);			// ファイル１つを解凍
	status_t	Extract(BPositionIO *oOutDest);				// ファイル１つを解凍
//	status_t	ExtractAll(const char *oDestFolder);		// ファイル全部を解凍
//	status_t	ExtractAll(BPositionIO *oOutDest);			// ファイル全部を解凍
	status_t	GetHeader(TLzhHeader *oHdr);				// 現在のファイルポインタからヘッダの内容を取得
	status_t	SeekNext();									// ファイルポインタを次のヘッダの先頭にセット
	status_t	SetTo(BPositionIO *oArc);					// 操作対象の書庫を指定

private:
	unsigned short	CalcCrc(unsigned char *p,unsigned int n,TMeltInfo *oMeltInfo);
	long			CopyFile(BPositionIO *oInSrc,BPositionIO *oOutDest,long oCopySize,int oCrcFlg,TMeltInfo *oMeltInfo);
	status_t		Decode(BPositionIO *oInSrc,BPositionIO *oOutDest,TMeltInfo *oMeltInfo);			// | 例外
	int				DecodeLzhuf(BPositionIO *oInSrc,BPositionIO *oOutDest,TMeltInfo *oMeltInfo);	// | 例外
	string			ExtractFileName(const string &xFullPath);			//ファイル名の抜き出し
	string			ExtractFilePath(const string &xFullPath);			//ファイルパス（'/'付き）の抜き出し
	status_t		SeekBegin();										// ファイルポインタを先頭にセット
	void			UpdateCrc(unsigned char c,TMeltInfo *oMeltInfo);
	status_t		WriteCrc(unsigned char *p,int n,BPositionIO *oOutDest,TMeltInfo *oMeltInfo);	// | 例外

	BPositionIO*	mArc;		// 操作対象の書庫
	TLzhHeader*		mLatestHdr;	// 直前に読み込んだヘッダ
};
//==============================================================================
#endif	//__LHAKernel_H_
