#include <InterfaceDefs.h>

/*============================================================================*/
const char*	gAppName      = "Trans LHA Archiver";
const char*	gAppVer       = "Ver 1.20";
const char*	gCrightPrfx   = "Copyright "B_UTF8_COPYRIGHT" 2000 by ＳＨＩＮＴＡ";
const char*	gOrgLHAKernel = "LHa for UNIX by t.okamoto etc.";
const char*	gAppSignature = "application/x-vnd.SHINTA-TransLHAArchiver";
const char*	gBuild        = "2000.12.24";
/*============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2000.11.26.Su 開発着手。
 1.00 | 2000.12.18.Mo オリジナルバージョン。
 1.10 | 2000.12.24.Su MimeType 登録機能をつけた。
 1.20 | 2000.12.28.Th -lh0- 形式の解凍をサポートした。
==============================================================================*/

/*==============================================================================
ＬＨＡカーネルの著作権表示は、LHAKernel.cpp を参照
==============================================================================*/

/*=== Memo =====================================================================
コンフィグ画面
深い階層に対して Identify されない OK?

OK ＤＯＳのファイルを読んだら SJIS -> UTF-8
OK -lh0-
OK 解凍後に Identify
==============================================================================*/

//------------------------------------------------------------------------------
#include "TransLHAApp.h"
//------------------------------------------------------------------------------
#ifdef DEBUG
#include <File.h>
#include "VPLHAKernel.h"
#include "LHAKernel.h"
#include <add/SHIDebug.h>
#endif
//------------------------------------------------------------------------------
#ifndef	BUILDING_TRANS_ARCHIVER
#error	"Define BUILDING_TRANS_ARCHIVER"
#endif
//------------------------------------------------------------------------------
//==============================================================================
TTransLHAApp::TTransLHAApp()
		: SUPER(gAppSignature)
{
}
//------------------------------------------------------------------------------
TTransLHAApp::~TTransLHAApp()
{
}
//==============================================================================
int		main(int oArgC,char *oArgV[])
{
#ifdef DEBUGz
	if ( oArgC == 1 )
		return 0;
	BFile	aArc(oArgV[1],B_READ_ONLY);
	BFile	aExt("/boot/home/WorkData/MeltedArc",B_READ_WRITE|B_CREATE_FILE|B_ERASE_FILE);
	TLHAKernel	aKernel;
//	aKernel.cmd_extract(&aArc,&aExt);
	TLzhHeader	aHdr;
	aHdr.Set(&aArc);
//	status_t	aResult = aKernel.Extract(&aArc,&aExt,aHdr);
	status_t	aResult = aKernel.Extract(&aArc,"/boot/home/WorkData/hogehoge/",aHdr);
	if ( aResult != B_OK ) {
		DBEXP("fail : result code",aResult);
	} else {
		DBEXP("Melt success!","");
	}
#endif
	return 0;
}
//==============================================================================
