#ifndef	___TransLHAArchiver_H_
#define	___TransLHAArchiver_H_
//------------------------------------------------------------------------------
#include <list>
#include "TransArchiver.h"
//------------------------------------------------------------------------------
using namespace	std;
//------------------------------------------------------------------------------
#define			BITMAP_MIME					"image/x-be-bitmap"			/* ビットマップの MIME */
#define			BITMAP_NAME					"Be Bitmap Format (Trans LHA Archiver Handler)"	/* ビットマップの名前 */
#define			TRANS_LHA_ARCHIVER_TGT_MIME	"application/x-LHA-Archive"	/* 変換後のデータの MIME */
#define			TRANS_LHA_ARCHIVER_TGT_NAME	"LHA Archive"				/* 変換後のデータの名前 */
//------------------------------------------------------------------------------
const char		MSGNAME_EXTS[] = "extensions";							// Mime登録用
//------------------------------------------------------------------------------
const char		LHA_ARCHIVE_EXT[] = "lzh";								// ＬＨＡ書庫の拡張子
const char		LHA_ARCHIVE_LARGE_ICON[] = "LZHLargeIcon";				// リソース取得用
const char		LHA_ARCHIVE_MINI_ICON[] = "LZHMiniIcon";					// リソース取得用
const uint32	TRANS_LHA_ARCHIVER_TGT_TYPE = 'lzh ';					// 変換後のデータのタイプ
const float		TRANS_LHA_ARCHIVER_CAPACITY = 0.7;						// デコード性能
const float		TRANS_LHA_ARCHIVER_QUALITY = 0.7;						// エンコード性能
//==============================================================================
class	TTransLHAArchiver : public TTransArchiver
{
public:
	TTransLHAArchiver();

	// トランスアーカイバ部
	virtual status_t	GetAllIndividualInfos(list<TIndividualInfo> *oInfos);	// 書庫中の全てのファイルの情報をコンテナに格納
	virtual status_t	Melt(const list<const char *> &oMeltFiles,const char *oDestFolder);	// 指定したファイルを解凍
	virtual status_t	MeltAll(const char *oDestFolder);						// 書庫を全て解凍

	// トランスレータ部
	virtual status_t	Identify(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo,uint32 oOutType);
	virtual const translation_format*	InputFormats(int32 *oOutCount) const;
	virtual const translation_format*	OutputFormats(int32 *oOutCount) const;
	virtual int32		SubClassCompatiIdent() const;								// 派生クラスＤＬＬにリンク
	virtual status_t	Translate(BPositionIO *oInSource,const translator_info *oInInfo,BMessage *oIoExtension
			,uint32 oOutType,BPositionIO *oOutDestination);
	virtual const char*	TranslatorInfo() const;
	virtual const char*	TranslatorName() const;
	virtual int32		TranslatorVersion() const;

protected:
private:
	typedef	TTransArchiver	SUPER;

	~TTransLHAArchiver();

	bool		FindFileName(const list<const char *> &oMeltFiles,const char *oTgtFName);	// ファイルがリスト中にあるか検索
	status_t	IdentifyToBits(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo);	// ビッツ形式への変換を認識
	status_t	IdentifyToLzh(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo);	// ＬＺＨ形式への変換を認識
	status_t	IdentifyToRaw(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo);	// 解凍形式への変換を認識
	void		InstallMime();									// 書庫のファイルタイプを登録
	status_t	TranslateBitsToLzh(BPositionIO *oInSource,const translator_info *oInInfo,BMessage *oIoExtension
			,BPositionIO *oOutDestination);	// ビッツからＬＺＨに変換
	status_t	TranslateLzhToBits(BPositionIO *oInSource,const translator_info *oInInfo,BMessage *oIoExtension
			,BPositionIO *oOutDestination);	// ＬＺＨからビッツに変換
};
//------------------------------------------------------------------------------
extern "C" _EXPORT BTranslator*	make_nth_translator(int32 oN,image_id oYou,uint32 oFlags, ...);
//==============================================================================

//------------------------------------------------------------------------------
//==============================================================================
#endif	//___TransLHAArchiver_H_
