/*==============================================================================

	～～～　ＬＨＡ圧縮解凍心臓部用　各種クラス定義　～～～

元のソース：

	LHa for UNIX Ver 1.14h + Ver 1.14i 差分

元のソースの著作権表示：

	LHAKernel.cpp を参照

ＢeＯＳ用に修正・新規作成：

	Modified		by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.00		First Version 2000.12.17(Sun) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.01		少し整理した 2000.12.25(Mon) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.02		エラーコード返却に関する修正 2000.12.28(Thu) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.03		日本語のファイル名も扱えるようにした 2000.12.28(Thu) by ＳＨＩＮＴＡ (SHINTA)
	Ver 1.04		圧縮形式を読み取るようにした 2000.12.28(Thu) by ＳＨＩＮＴＡ (SHINTA)

==============================================================================*/

/*== MEMO ======================================================================
TDecodeSetに移せる？
	TMeltInfo::pt_table,mSubBitBuf
==============================================================================*/

#include "VPLHAKernel.h"
//------------------------------------------------------------------------------
#include <UTF8.h>
#include <add/SHIDebug.h>
//------------------------------------------------------------------------------
static char*	sgMethodStrs[] =
{
	LZHUFF0_METHOD,LZHUFF1_METHOD,LZHUFF2_METHOD,LZHUFF3_METHOD,
	LZHUFF4_METHOD,LZHUFF5_METHOD,LZHUFF6_METHOD,LZHUFF7_METHOD,
	LARC_METHOD,LARC5_METHOD,LARC4_METHOD,
	NULL
};
//==============================================================================
TException::TException(int32 i3ID,const char *cString)
{
	mi3ID = i3ID;
	mxString = cString;
}
//------------------------------------------------------------------------------
TException::TException(const char *cString)
{
	mi3ID = 0;
	mxString = cString;
}
//------------------------------------------------------------------------------
TException::~TException()
{
}
//------------------------------------------------------------------------------
const char*	TException::String() const
{
	return mxString.c_str();
}
//------------------------------------------------------------------------------
int32	TException::ID() const
{
	return mi3ID;
}
//==============================================================================
TLzhHeader::TLzhHeader()
{
	mHasCrc = false;
	mMethodStr[0] = '\0';
	mName[0] = '\0';
	mDosFileAttr = 0;
	mExtendType = 0;
	mHdrLevel = 0;
	mMinorVersion = 0;
	mCrc = 0;
	mUnixGid = 0;
	mUnixMode = 0;
	mUnixUid = 0;
	mDosLastModifiedStamp = -1;
	mOriginalSize = -1;
	mFrozenSize = -1;
	mUnixLastModifiedStamp = 0;
}
//------------------------------------------------------------------------------
TLzhHeader::~TLzhHeader()
{
}
//------------------------------------------------------------------------------
void	TLzhHeader::CalcMethodNum()
{
	for ( mMethodNum = 0 ; ; mMethodNum++ ) {
		if ( sgMethodStrs[mMethodNum] == NULL) {
//			error("Unknown aMethod skiped ...", aName);
			mMethodNum = -1;
			return;
		}
		if ( memcmp(mMethodStr,sgMethodStrs[mMethodNum],METHOD_TYPE_STRAGE) == 0 )
			break;
	}
}
//------------------------------------------------------------------------------
int		TLzhHeader::CalcSum(char *oPtr,int oLen)
{
	int		aSum;

	for ( aSum = 0 ; oLen ; oLen-- ) {
		aSum += *oPtr++;
	}
	return (aSum & 0xFF);
}
//------------------------------------------------------------------------------
char*	TLzhHeader::ConvDelim(char *oPath,char oDelim)
/* ''''''''''''''''''''''''''''''
oPath のデリミタを破壊的に変換し、結果を返す
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	char*			p;
	unsigned char	c;

	for ( p = oPath ; (c = *p) != 0 ; p++ ) {
		if ( c == '\\' || c == DELIM || c == DELIM2 ) {
			*p = oDelim;
			oPath = p+1;
		}
	}
	return oPath;
}
//------------------------------------------------------------------------------
void	TLzhHeader::GenericToUnixFileName(char *oName,int oLen)
{
	bool	aLowerCaseUsed = false;

#ifdef MULTIBYTE_CHAR
	for (i = 0; i < len; i++) {
		if (MULTIBYTE_FIRST_P(name[i]) &&
		    MULTIBYTE_SECOND_P(name[i + 1]))
			i++;
		else if (islower(name[i])) {
			lower_case_used = true;
			break;
		}
	}
	for (i = 0; i < len; i++) {
		if (MULTIBYTE_FIRST_P(name[i]) &&
		    MULTIBYTE_SECOND_P(name[i + 1]))
			i++;
		else if (name[i] == '\\')
			name[i] = '/';
		else if (!noconvertcase && !lower_case_used && isupper(name[i]))
			name[i] = tolower(name[i]);
	}
#else
	for ( int i = 0 ; i < oLen ; i++ ) {
		if ( islower(oName[i]) ) {
			aLowerCaseUsed = true;
			break;
		}
	}
	for ( int i = 0 ; i < oLen ; i++ ) {
		if ( oName[i] == '\\' ) {
			oName[i] = '/';
		}
//		else if (!noconvertcase && !lower_case_used && isupper(name[i]))
//			name[i] = tolower(name[i]);
	}
#endif
}
//------------------------------------------------------------------------------
time_t	TLzhHeader::GenericToUnixStamp(long oGenericTime)
{
	struct tm	aDosTm;

	/*
	 * special case:  if MSDOS format date and time were zero, then we
	 * set time to be zero here too.
	 */
	if ( oGenericTime == 0 )
		return static_cast<time_t>(0);
	// 各値の設定
	aDosTm.tm_sec = (oGenericTime & 0x1F)*2;
	aDosTm.tm_min = oGenericTime >> 5 & 0x3F;
	aDosTm.tm_hour = oGenericTime >> 11 & 0x1F;
	aDosTm.tm_mday = oGenericTime >> 16 & 0x1F;
	aDosTm.tm_mon = (oGenericTime >> 16 + 5 & 0x0F)-1;	/* 0..11 */
	aDosTm.tm_year = (oGenericTime >> 16 + 9 & 0x7F)+80;
	aDosTm.tm_isdst = -1;	/* correct? */
//#ifdef MKTIME
	return mktime(&aDosTm);
//#else				/* maybe defined(TIMELOCAL) */
//	return (time_t) timelocal(&dostm);
//#endif
}
//------------------------------------------------------------------------------
int		TLzhHeader::GetByte()
{
	return (*mHdrPtr++ & 0xFF);
}
//------------------------------------------------------------------------------
long	TLzhHeader::GetLongword()
{
	long	b0, b1, b2, b3;

	b0 = GetByte();
	b1 = GetByte();
	b2 = GetByte();
	b3 = GetByte();
	return (b3 << 24) + (b2 << 16) + (b1 << 8) + b0;
}
//------------------------------------------------------------------------------
char*	TLzhHeader::GetPtr()
{
	return mHdrPtr;
}
//------------------------------------------------------------------------------
unsigned short	TLzhHeader::GetWord()
{
	int		b0, b1;

	b0 = GetByte();
	b1 = GetByte();
	return (b1 << 8) + b0;
}
//------------------------------------------------------------------------------
status_t	TLzhHeader::Scan(BPositionIO *oInSrc)
{
	char	aCvtBuf[B_FILE_NAME_LENGTH];
	char	aData[LZHEADER_STRAGE];
	char	aDirName[B_FILE_NAME_LENGTH];
	char	aReadBuf[32];
	char*	aPtr;
	int		aCheckSum;
	int		aDirNameLen = 0;
	int		aExtendSize;
	int		aHdrSize;
	int		aNameLen;
	int		i;
	int32	aDestLen;
	int32	aSrcLen;

	try {
		// ヘッダサイズ
		if ( oInSrc->Read(aReadBuf,1) < 1 )
			return TLA_ERR_EOF;	// 終了
		aHdrSize = aReadBuf[0];
		if ( aHdrSize == 0 )
			return TLA_ERR_EOF;	// 終了
		if ( aHdrSize < 0 )	// 仮
			throw TException(B_ERROR);
		// ヘッダレベル
		if ( oInSrc->Read(aData+I_HEADER_CHECKSUM,aHdrSize-1) < aHdrSize-1 ) {
			DBEXP("TLHAKernel::get_header","Invalid header (LHarc file ?)");	//error
			throw TException(B_ERROR);
		}
		SetupGet(aData+I_HEADER_LEVEL);
		mHdrLevel = GetByte();
		if ( mHdrLevel != 2 && oInSrc->Read(aData+aHdrSize,2) < 2 ) {
			DBEXP("TLHAKernel::get_header","Invalid header (LHarc file ?)");	//error
			throw TException(B_ERROR);
		}
		if ( mHdrLevel >= 3 ) {
			DBEXP("TLHAKernel::get_header","Unknown level header");	//error
			throw TException(B_ERROR);
		}
		// チェックサム
		SetupGet(aData+I_HEADER_CHECKSUM);
		aCheckSum = GetByte();
		// ??
		if ( mHdrLevel == 2 ) {
			aHdrSize += aCheckSum*256;
		}
		// メソッド
		memmove(mMethodStr,aData+I_METHOD,METHOD_TYPE_STRAGE);
		CalcMethodNum();
		if ( mMethodNum == -1 )
			throw TException(B_ERROR);
		// 各種情報
		SetupGet(aData+I_PACKED_SIZE);
		mFrozenSize = GetLongword();
		mOriginalSize = GetLongword();
		mDosLastModifiedStamp = GetLongword();
		mDosFileAttr = GetByte();
		// 再びヘッダレベルを設定？ してから、名前の取得
		if ( (mHdrLevel = GetByte()) != 2 ) {
			if ( CalcSum(aData+I_METHOD,aHdrSize) != aCheckSum ) {
				DBEXP("Checksum error (LHarc file?)", "");	//warning
				throw TException(B_ERROR);
			}
			aNameLen = GetByte();
			for ( i = 0 ; i < aNameLen ; i++ ) {
				mName[i] = static_cast<char>(GetByte());
			}
			mName[aNameLen] = '\0';
		}
		else {
			mUnixLastModifiedStamp = mDosLastModifiedStamp;
			aNameLen = 0;
		}
		// デフォルト値の設定？
		mUnixMode = UNIX_FILE_REGULAR | UNIX_RW_RW_RW;
		mUnixGid = 0;
		mUnixUid = 0;
		// ヘッダレベルごとの設定
		switch ( mHdrLevel ) {
		case 0:
			aExtendSize = aHdrSize-aNameLen-22;	// ??: 22って何？
			if ( aExtendSize < 0 ) {
				if ( aExtendSize == -2 ) {
					mExtendType = EXTEND_GENERIC;
					mHasCrc = false;
				} else {
					DBEXP("TLzhHeader::Set","Unkonwn header (lha file?)");	//fatal_error
					throw TException(B_ERROR);
				}
			} else {
				mHasCrc = true;
				mCrc = GetWord();
			}
			if ( aExtendSize >= 1 ) {
				mExtendType = GetByte();
				aExtendSize--;
			}
			if ( mExtendType == EXTEND_UNIX ) {
				if ( aExtendSize >= 11 ) {
					mMinorVersion = GetByte();
					mUnixLastModifiedStamp = static_cast<time_t>(GetLongword());
					mUnixMode = GetWord();
					mUnixUid = GetWord();
					mUnixGid = GetWord();
					aExtendSize -= 11;
				} else {
					mExtendType = EXTEND_GENERIC;
				}
			}
			while ( aExtendSize-- > 0 ) {
				GetByte();	// dummy =
			}
			if ( mExtendType == EXTEND_UNIX ) {
				return B_OK;
			}
			break;
		case 1:
			mHasCrc = true;
			aExtendSize = aHdrSize-aNameLen-25;
			mCrc = GetWord();
			mExtendType = GetByte();
			while ( aExtendSize-- > 0 ) {
				GetByte();	// dummy =
			}
			break;
		case 2:
			mHasCrc = true;
			mCrc = GetWord();
			mExtendType = GetByte();
			break;
		default:
			ASSERT(1,"TLzhHeader::Set - 不正なヘッダレベル");
		}		
		// また、ヘッダレベルごとの設定
		if ( mHdrLevel > 0 ) {
			// 拡張ヘッダ
			if ( mHdrLevel != 2 ) {
				SetupGet(aData+aHdrSize);
			}
			aPtr = GetPtr();
			while ( (aHdrSize = GetWord()) != 0 ) {
				if ( mHdrLevel != 2
						&& ((aData+LZHEADER_STRAGE-GetPtr() < aHdrSize) || oInSrc->Read(GetPtr(),aHdrSize) < aHdrSize) ) {
					DBEXP("TLzhHeader::Set","Invalid header (LHa file ?)");	//fatal_error
					throw TException(B_ERROR);
				}
				switch ( GetByte() ) {
				case 0:	// ヘッダのＣＲＣ
					SetupGet(GetPtr()+aHdrSize-3);
					break;
				case 1:	// ファイル名
					for ( i = 0 ; i < aHdrSize-3 ; i++ ) {
						mName[i] = static_cast<char>(GetByte());
					}
					mName[aHdrSize-3] = '\0';
					aNameLen = aHdrSize-3;
					break;
				case 2:	// フォルダ
					for ( i = 0 ; i < aHdrSize-3 ; i++ ) {
						aDirName[i] = static_cast<char>(GetByte());
					}
					aDirName[aHdrSize-3] = '\0';
					ConvDelim(aDirName,DELIM);
					aDirNameLen = aHdrSize-3;
					break;
				case 0x40:	// MS-DOS ファイル属性
					if ( mExtendType == EXTEND_MSDOS || mExtendType == EXTEND_HUMAN
							|| mExtendType == EXTEND_GENERIC ) {
						mDosFileAttr = GetWord();
					}
					break;
				case 0x50:	// UNIX パーミッション
					if ( mExtendType == EXTEND_UNIX ) {
						mUnixMode = GetWord();
					}
					break;
				case 0x51:	// UNIX GID,UID
					if ( mExtendType == EXTEND_UNIX ) {
						mUnixGid = GetWord();
						mUnixUid = GetWord();
					}
					break;
				case 0x52:	// UNIX グループ名
					SetupGet(GetPtr()+aHdrSize-3);
					break;
				case 0x53:	// UNIX ユーザー名
					SetupGet(GetPtr()+aHdrSize-3);
					break;
				case 0x54:	// UNIX 更新日時
					if ( mExtendType == EXTEND_UNIX ) {
						mUnixLastModifiedStamp = static_cast<time_t>(GetLongword());
					}
					break;
				default:	// その他のヘッダ
					SetupGet(GetPtr()+aHdrSize-3);
					break;
				}
			}
			if ( mHdrLevel != 2 && GetPtr()-aPtr != 2 ) {
				mFrozenSize -= GetPtr()-aPtr-2;
				aHdrSize += GetPtr()-aPtr-2;
			}
		}
		// 拡張タイプ別の処理
		switch ( mExtendType ) {
		case EXTEND_MSDOS:
//			msdos_to_unix_filename(mName,aNameLen);
//			msdos_to_unix_filename(aDirName,aDirNameLen);
		case EXTEND_HUMAN:
			if ( mHdrLevel == 2 ) {
				mUnixLastModifiedStamp = mDosLastModifiedStamp;
			} else {
				mUnixLastModifiedStamp = GenericToUnixStamp(mDosLastModifiedStamp);
			}
			break;
		case EXTEND_UNIX:
			break;
		default:
			GenericToUnixFileName(mName,aNameLen);
			GenericToUnixFileName(aDirName,aDirNameLen);
			if ( mHdrLevel == 2 ) {
				mUnixLastModifiedStamp = mDosLastModifiedStamp;
			} else {
				mUnixLastModifiedStamp = GenericToUnixStamp(mDosLastModifiedStamp);
			}
		}
		// ファイル名にフォルダ名を加える
		if ( aDirNameLen ) {
			strcat(aDirName,mName);
			strcpy(mName,aDirName);
			aNameLen += aDirNameLen;
		}
		// ファイル名の文字コードを変換
//		if ( mExtendType != EXTEND_BEOS ) {
		aSrcLen = strlen(mName);
		aDestLen = sizeof(aCvtBuf);
		convert_to_utf8(B_SJIS_CONVERSION,mName,&aSrcLen,aCvtBuf,&aDestLen,NULL);
//		DBEXP("aDestLen - TLzhHeader::Scan",aDestLen);
		strncpy(mName,aCvtBuf,aDestLen);	// VU:長さ溢れ対策（パスの前の方を削る？）
		mName[aDestLen] = '\0';
//		}
	} catch (TException oException) {
		return oException.ID();
	}
	return B_OK;
}
//------------------------------------------------------------------------------
void	TLzhHeader::SetupGet(char *oPtr)
{
	mHdrPtr = oPtr;
}
//==============================================================================
TMeltInfo::TMeltInfo(const TLzhHeader *oHdr)
		: mHdr(oHdr)
{
	mVerifyMode = false;
	mBitCount = 0;
	mSubBitBuf = 0;
	mBitBuf = 0;
	mBlockSize = 0;
	mRealCrc = 0;
	mDicBit = 0;
	mNP = 0;
	mPBit = 0;
	mPrevChar = 0;
	mCount = 0;
	mLeftFrozenSize = oHdr->FrozenSize();	// ??: 0かも
	mLoc = 0;
	mReadingSize = 0;

	memset(mCLen,'\0',sizeof(mCLen));
	memset(mPtLen,'\0',sizeof(mPtLen));
	memset(mCrcTable,'\0',sizeof(mCrcTable));
	memset(mCTable,'\0',sizeof(mCTable));
	memset(mLeft,'\0',sizeof(mLeft));
	memset(mRight,'\0',sizeof(mRight));
	memset(mPtTable,'\0',sizeof(mPtTable));

	mDecodeSet = NULL;
	MakeCrcTable();
}
//------------------------------------------------------------------------------
TMeltInfo::~TMeltInfo()
{
	delete mDecodeSet;
}
//------------------------------------------------------------------------------
unsigned short	TMeltInfo::DecodeC(BPositionIO *oInSrc)
{
	ASSERT(mDecodeSet == NULL,"TMeltInfo::DecodeC");
	return mDecodeSet->DecodeC(oInSrc,this);
}
//------------------------------------------------------------------------------
unsigned short	TMeltInfo::DecodeP(BPositionIO *oInSrc)
{
	ASSERT(mDecodeSet == NULL,"TMeltInfo::DecodeP");
	return mDecodeSet->DecodeP(oInSrc,this);
}
//------------------------------------------------------------------------------
void	TMeltInfo::MakeCrcTable()
{
	unsigned int	i,j,r;

	for ( i = 0 ; i <= UCHAR_MAX ; i++ ) {
		r = i;
		for ( j = 0 ; j < CHAR_BIT ; j++ ) {
			if ( r & 1 ) {
				r = (r >> 1) ^ CRCPOLY;
			} else {
				r >>= 1;
			}
		}
		mCrcTable[i] = r;
	}
}
//------------------------------------------------------------------------------
void	TMeltInfo::SetDecodeSet(TDecodeSet *oDecodeSet)
/* ''''''''''''''''''''''''''''''
oDecodeSet は、TMeltInfo の所有物となる
   ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,, */
{
	delete mDecodeSet;
	mDecodeSet = oDecodeSet;
}
//------------------------------------------------------------------------------
void	TMeltInfo::StartDecode(BPositionIO *oInSrc)
{
	ASSERT(mDecodeSet == NULL,"TMeltInfo::StartDecode");
	return mDecodeSet->StartDecode(oInSrc,this);
}
//==============================================================================
