#ifndef	___TransZipArchiver_H_
#define	___TransZipArchiver_H_
//------------------------------------------------------------------------------
#include "TransArchiver.h"
//------------------------------------------------------------------------------
#define			BITMAP_MIME					"image/x-be-bitmap"		/*ビットマップの MIME*/
#define			BITMAP_NAME					"Be Bitmap Format (Trans Zip Handler)"	/*ビットマップの名前*/
#define			TRANS_ZIP_ARCHIVER_TGT_MIME	"application/zip"			/*変換後のデータの MIME*/
#define			TRANS_ZIP_ARCHIVER_TGT_NAME	"Zip Archive"				/*変換後のデータの名前*/
//------------------------------------------------------------------------------
const char		FPERIEXT_ZIP[] = ".zip";								//Zipファイルの拡張子（ピリオド付き）
const char		LIST_FNAME[] = "List.txt";							//書庫内の一覧の出力先
const char		STORE_FNAME[] = "TransZipData";						//書庫中のファイル名
const char		VAR_FNAME_BASE[] = "TransZipTmp_";					//一時ファイル名
const int		VAR_FNAME_SUF_LENGTH = 7;							//一時ファイルの重複予防文字数
const uint32	TRANS_ZIP_ARCHIVER_TGT_TYPE = 'zip ';				//変換後のデータのタイプ
const float		TRANS_ZIP_ARCHIVER_CAPACITY = 0.7;					//デコード性能
const float		TRANS_ZIP_ARCHIVER_QUALITY = 0.7;					//エンコード性能
//==============================================================================
class	TTransZipArchiver : public TTransArchiver
{
public:
	TTransZipArchiver();

	//トランスアーカイバ部
	virtual status_t	Freeze(const list<const char *> &oFreezeFiles,const char *oBaseFolder = NULL);	//書庫にファイルを追加
	virtual status_t	GetAllIndividualInfos(list<TIndividualInfo> *oInfos);		//書庫中の全てのファイルの情報をコンテナに格納
	virtual status_t	Melt(const list<const char *> &oMeltFiles,const char *oDestFolder);				//指定したファイルを解凍
	virtual status_t	MeltAll(const char *oDestFolder);							//書庫を全て解凍
	virtual status_t	SetTo(const entry_ref *oArcRef,uint32 oOpenMode);			//操作対象の書庫を指定
	virtual void		Unset();													//操作対象の書庫の指定を解除

	//トランスレータ部
	virtual status_t	Identify(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo,uint32 oOutType);
	virtual const translation_format*	InputFormats(int32 *oOutCount) const;
//	virtual status_t	MakeConfigurationView(BMessage *oIoExtension,BView **oOutView
//			,BRect * oOutExtent);
	virtual const translation_format*	OutputFormats(int32 *oOutCount) const;
	virtual int32		SubClassCompatiIdent() const;								// 派生クラスＤＬＬにリンク
	virtual status_t	Translate(BPositionIO *oInSource,const translator_info *oInInfo,BMessage *oIoExtension
			,uint32 oOutType,BPositionIO *oOutDestination);
	virtual const char*	TranslatorInfo() const;
	virtual const char*	TranslatorName() const;
	virtual int32		TranslatorVersion() const;

protected:
private:
	typedef	TTransArchiver	SUPER;

	~TTransZipArchiver();

	void		DeleteFolder(const char *oFolderName);	// フォルダとその中身を削除
	string		EliminateBaseFolder(const char *oTgtFName,const char *oBaseFolder);	//基準ディレクトリの除去
	void		GenerateTmpFName(char *oDest) const;	//一時ファイル名（拡張子無し）の生成
	status_t	IdentifyToBits(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo);	//ビッツ形式への変換を認識
	status_t	IdentifyToZip(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo);	//ＺＩＰ形式への変換を認識
	status_t	IdentifyToRaw(BPositionIO *oInSource,const translation_format *oInFormat
			,BMessage *oIoExtension,translator_info *oOutInfo);	//解凍形式への変換を認識
	bool	IsSet() const;						//操作対象ファイルが指定されている
	void	MakeCommonMeltCmd(string *oCmdLine);	// 解凍コマンドの作成
	status_t	TranslateBitsToZip(BPositionIO *oInSource,const translator_info *oInInfo,BMessage *oIoExtension
			,BPositionIO *oOutDestination);	//ビッツからＺＩＰに変換
	status_t	TranslateZipToBits(BPositionIO *oInSource,const translator_info *oInInfo,BMessage *oIoExtension
			,BPositionIO *oOutDestination);	//ＺＩＰからビッツに変換

	char	mArcFName[B_FILE_NAME_LENGTH];	//操作対象の書庫

};
//------------------------------------------------------------------------------
extern "C" _EXPORT BTranslator*	make_nth_translator(int32 oN,image_id oYou,uint32 oFlags, ...);
//==============================================================================

//------------------------------------------------------------------------------
//==============================================================================
#endif	//___TransZipArchiver_H_
